# std::unordered_map::equal_range

From cppreference.com
< cpp‎ | container‎ | unordered map

std::pair<iterator,iterator> equal_range( const Key& key ); |  | (since C++11)
std::pair<const_iterator,const_iterator> equal_range( const Key& key ) const; |  | (since C++11)

Returns a range containing all elements with key `key` in the container. The range is defined by two iterators, the first pointing to the first element of the wanted range and the second pointing past the last element of the range.

### Parameters

key | - | key value to compare the elements to

### Return value

std::pair containing a pair of iterators defining the wanted range. If there are no such elements, past-the-end (see end()) iterators are returned as both elements of the pair.

### Complexity

Average case linear in the number of elements with the key `key`, worst case linear in the size of the container.

### Example

Run this code

    #include <iostream>
    #include <unordered_map>

    int main()
    {
        std::unordered_map<int,char> map = {{1,'a'},{1,'b'},{1,'d'},{2,'b'}};
        auto range = map.equal_range(1);
        for (auto it = range.first; it != range.second; ++it) {
            std::cout << it->first << ' ' << it->second << '\n';
        }
    }

Output:

    1 a

### See also

find | finds element with specific key (public member function)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/container/unordered_map/equal_range&oldid=65097"